Bug 853922 - Review Request: guacamole - The main Guacamole web application
Review Request: guacamole - The main Guacamole web application
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tomas Radej
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-03 06:23 EDT by Simone Caronni
Modified: 2013-02-15 07:18 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-15 07:18:21 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tradej: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Simone Caronni 2012-09-03 06:23:34 EDT
Spec URL: http://slaanesh.fedorapeople.org/guacamole.spec
SRPM URL: http://slaanesh.fedorapeople.org/guacamole-0.6.1-1.fc17.src.rpm
Description:
Guacamole is an HTML5 web application that provides access to desktop
environments using remote desktop protocols such as VNC or RDP. A centralized
server acts as a tunnel and proxy, allowing access to multiple desktops through
a web browser. No plugins are needed: the client requires nothing more than a
web browser supporting HTML5 and AJAX.

Fedora Account System Username: slaanesh
Comment 1 Simone Caronni 2012-09-03 06:33:04 EDT
This is my first Java Web Application package, so a few notes on this from what I evicted from the various packaging guidelines:

* guacamole-common-js has been removed as a build dependency:

According to the guidelines, javascript need to be left as they are in exploded format on the filesystem, so they are not used during build but only linked into the app like normal jar files.

* tomcat dependency

To enable the app, the link to /usr/share/webapps/guacamole/guacamole needs to be available in the tomcat webapps directory. I've put the generic tomcat name (so version 7) as requirement, but it works fine as well in tomcat6.

What's the standard here? Don't ship the link so the user needs to enable it by hand, ship it for all tomcat versions, ship just for the generic one?...

https://fedoraproject.org/wiki/PackagingDrafts/JavaWebApps
https://fedoraproject.org/wiki/PackagingDrafts/JavaScript
https://fedoraproject.org/wiki/Packaging:Java
Comment 2 Stanislav Ochotnicky 2012-09-03 10:48:23 EDT
I don't quite understand why there's double name macro: 
%{_datadir}/webapps/%{name}/%{name}/
Comment 3 Simone Caronni 2012-09-03 10:56:46 EDT
It's in the "Server Independent Part" [1]:

"According to existing practice, the web application data should be placed to %{_datadir}. The package can contain more than a single web application -- it can contain a GUI or CLI application, either of them possibly using %{_datadir}/%{name}, or multiple web applications. A web application is possibly named differently from the package. Therefore use of %{_datadir}/%{_name} should be avoided.

A suitable name, what would prevent all sorts of naming conflicts would be %{_datadir}/webapps/%{name}/foo. Note that the name webapps was chosen after existing naming practice of Tomcat. foo stands for name of the web application archive stripped of .war suffix, since it's no longer an archive."

https://fedoraproject.org/wiki/PackagingDrafts/JavaWebApps#Server_independent_part
Comment 4 Simone Caronni 2012-09-13 07:41:24 EDT
Updated Source URL.

Spec URL: http://slaanesh.fedorapeople.org/guacamole.spec
SRPM URL: http://slaanesh.fedorapeople.org/guacamole-0.6.1-2.fc17.src.rpm
Comment 6 Simone Caronni 2012-11-30 11:52:10 EST
Updated, with a couple of fixes.

Spec URL: http://slaanesh.fedorapeople.org/guacamole.spec
SRPM URL: http://slaanesh.fedorapeople.org/guacamole-0.6.2-2.fc17.src.rpm

I have a couple of issues with tomcat, though.

1) log4j

It's required by tomcat but not installed by default. Symlinks are provided in tomcat but not the relevant jars and tomcat does not require package "log4j". Should I file a bug?

[root@localhost lib]# pwd
/usr/share/tomcat/lib
[root@localhost lib]# ls -al log4j*
lrwxrwxrwx. 1 root root 25 30 nov 16.29 log4j.jar -> /usr/share/java/log4j.jar
[root@localhost lib]# rpm -qf log4j.jar /usr/share/java/log4j.jar
tomcat-lib-7.0.32-1.fc18.noarch
log4j-1.2.17-3.fc18.noarch

2) tomcat-native

Tomcat complains about the missing Apache APR libraries, but those seem to be not required. Should they be pulled in or not by Tomcat?

3) web application context.xml

According to the Java WebApps packaging guidelines, shortcuts should be created for jar files. But this means adding the option to follow symlinks in context.xml.

Is this the wanted behaviour?
Comment 7 Simone Caronni 2012-11-30 12:18:52 EST
Some notes on how to test the application.

Prerequisites: an rdp or vnc server reachable for making the connections.

1) Install all the required tools and packages:

yum -y install tomcat tomcat-native log4j
yum -y install libguac* guacd
yum -y localinstall guacamole-0.6.2-2.fc17.noarch.rpm

2) Configure connections:

vi /etc/guacamole/user-mapping.xml

Documentation is here:

http://guac-dev.org/Configuring%20Guacamole

3) Enable and start all services:

systemctl enable guacd.service
systemctl start guacd.service
systemctl enable tomcat.service
systemctl start tomcat.service

4) Connect to web application

Point your browser to:

http://localhost:8080/guacamole/
Comment 8 Tomas Radej 2012-12-13 06:41:07 EST
I'll take it.
Comment 9 Simone Caronni 2012-12-13 09:12:05 EST
(In reply to comment #8)
> I'll take it.

Many thanks!
Comment 10 Tomas Radej 2012-12-19 11:27:04 EST
The package does not build. The required guacamole-common = 0.6.2 is missing, it was already updated to 0.7.0. Please, fix the requirements before I proceed with the review.
Comment 11 Simone Caronni 2012-12-19 13:06:47 EST
Yes, I updated the prerequisites yesterday. Here is the update:

Spec URL: http://slaanesh.fedorapeople.org/guacamole.spec
SRPM URL: http://slaanesh.fedorapeople.org/guacamole-0.7.0-1.fc17.src.rpm

There are also the prerequisites pending for f17/f18 if you want to test on those platforms:

https://admin.fedoraproject.org/updates/search/guacamole
Comment 12 Simone Caronni 2013-01-14 04:50:11 EST
Hello,

any news regarding the review?

Thanks,
--Simone
Comment 13 Mikolaj Izdebski 2013-01-14 06:42:24 EST
Builds fine now:
https://koji.fedoraproject.org/koji/taskinfo?taskID=4866654
Comment 14 Tomas Radej 2013-01-14 09:33:37 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed

Issues:

[!]: Package complies to the Packaging Guidelines
>>>> Issues are described below:

[!]: Package requires other packages for directories it uses.
>>>> You are using directories owned by tomcat (e. g. the line 85 or 99).
>>>> You need to put Requires: tomcat to your spec file. That also makes
>>>> the creation of the folders redundant.

[!]: Requires correct, justified where necessary.
>>>> The packages you mention in 'how to test' and packages owning files that
>>>> you link to (line 78+ in guacamole.spec) must be mentioned in Requires,
>>>> so that they are installed automatically. That is the point of having
>>>> things packaged in the first place. Please, put all the required packages
>>>> into Requires.

[!]: Package obeys FHS, except libexecdir and /usr/target.
>>>> As far as I understand, Guacamole is a tomcat web app. Since web app
>>>> guidelines aren't in place yet, I hereby ask you not to install guacamole
>>>> into /usr/share/webapps. That is for two reasons: a) the directory isn't
>>>> owned by any package (see
>>>> http://fedoraproject.org/wiki/Packaging:Guidelines#File_and_Directory_Ownership)
>>>> and b) If you created the package to own that directory, and the final
>>>> version of the guidelines was different from the current one, it would
>>>> take a great amount of work to migrate the existing solution to the one
>>>> compliant with the approved guidelines. So, until the Web App Guidelines
>>>> are approved and in place, I hereby ask you to refrain from installing
>>>> anything in the /usr/share/webapps directory. Please use only
>>>> /var/lib/tomcat/webapps.

>>>> Also, I am not convinced that the file guacamole.properties should be
>>>> installed in /usr/share/tomcat/lib. For one, it's not a library, and
>>>> since stuff in /usr is read-only, it makes no sense to have a config
>>>> file in there. Having the file in /etc/guacamole should be enough.

[!]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
>>>> Pom.xml file is present, but is not installed. Please, install it.

[!]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
>>>> Line 96 should not copy the apidocs folder, but its contents:
>>>> cp -rp target/site/apidocs/* %{buildroot}%{javadocdir}/%{name}/
>>>> Currently there is the unnecessary directory apidocs in the path.

Notes:

[!]: Packages should try to preserve timestamps of original installed files.
>>>> You are copying files without the -p switch, which preserves timestamps.
>>>> It is not mandatory, but it would be nice having it.

[ ]: Package Description
>>>> It would be nice if the description didn't start with the word Guacamole.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[!]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in %package
     javadoc
[!]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "AGPL (v3 or later)". 1 files have unknown license. Detailed output of
     licensecheck in /home/tradej/reviews/853922-guacamole/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: No %config files under /usr.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[!]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[!]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 81920 bytes in 3 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
[x]: Fully versioned dependency in subpackages, if present.
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages have Requires: jpackage-utils
[!]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
[x]: Bundled jar/class files should be removed before build

Maven:
[x]: Old add_to_maven_depmap macro is not being used
[!]: If package contains pom.xml files install it (including depmaps) even
     when building with ant

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[x]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

Java:
[x]: Package has BuildArch: noarch (if possible)
[x]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: guacamole-0.7.0-1.fc19.noarch.rpm
          guacamole-0.7.0-1.fc19.src.rpm
          guacamole-javadoc-0.7.0-1.fc19.noarch.rpm
guacamole.noarch: W: name-repeated-in-summary C Guacamole
guacamole.noarch: W: invalid-license AGPLv3+
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/guacamole-common.jar /usr/share/java/guacamole/guacamole-common.jar
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/guacamole-common-js /usr/share/guacamole-common-js
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/jcl-over-slf4j.jar /usr/share/java/slf4j/jcl-over-slf4j.jar
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/guacamole-ext.jar /usr/share/java/guacamole/guacamole-ext.jar
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/api.jar /usr/share/java/slf4j/api.jar
guacamole.src: W: name-repeated-in-summary C Guacamole
guacamole.src: W: invalid-license AGPLv3+
guacamole-javadoc.noarch: W: invalid-license AGPLv3+
3 packages and 0 specfiles checked; 0 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint guacamole-javadoc guacamole
guacamole-javadoc.noarch: W: invalid-license AGPLv3+
guacamole.noarch: W: name-repeated-in-summary C Guacamole
guacamole.noarch: W: invalid-license AGPLv3+
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/guacamole-common.jar /usr/share/java/guacamole/guacamole-common.jar
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/guacamole-common-js /usr/share/guacamole-common-js
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/jcl-over-slf4j.jar /usr/share/java/slf4j/jcl-over-slf4j.jar
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/guacamole-ext.jar /usr/share/java/guacamole/guacamole-ext.jar
guacamole.noarch: W: dangling-symlink /usr/share/webapps/guacamole/guacamole/WEB-INF/lib/api.jar /usr/share/java/slf4j/api.jar
2 packages and 0 specfiles checked; 0 errors, 8 warnings.
# echo 'rpmlint-done:'



Requires
--------
guacamole-0.7.0-1.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    config(guacamole) = 0.7.0-1.fc19
    guacamole-common = 0.7.0
    guacamole-common-js = 0.7.0
    guacamole-ext = 0.7.0
    java  
    jpackage-utils  

guacamole-javadoc-0.7.0-1.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    jpackage-utils  



Provides
--------
guacamole-0.7.0-1.fc19.noarch.rpm:
    
    config(guacamole) = 0.7.0-1.fc19
    guacamole = 0.7.0-1.fc19

guacamole-javadoc-0.7.0-1.fc19.noarch.rpm:
    
    guacamole-javadoc = 0.7.0-1.fc19



MD5-sum check
-------------
http://downloads.sourceforge.net/guacamole/guacamole-0.7.0.tar.gz :
  CHECKSUM(SHA256) this package     : 65bce57269c249423d07fce12692e26f88a8c67f25f77ee854177d406743fbaf
  CHECKSUM(SHA256) upstream package : 65bce57269c249423d07fce12692e26f88a8c67f25f77ee854177d406743fbaf


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 853922 -m fedora-rawhide-x86_64

*** NOT APPROVED ***

Issues and notes are at the top of this comment. Until those are fixed,
I may not approve the package.
Comment 15 Simone Caronni 2013-01-15 09:59:50 EST
> [!]: Package requires other packages for directories it uses.
> >>>> You are using directories owned by tomcat (e. g. the line 85 or 99).
> >>>> You need to put Requires: tomcat to your spec file. That also makes
> >>>> the creation of the folders redundant.

Corrected.
 
> [!]: Requires correct, justified where necessary.
> >>>> The packages you mention in 'how to test' and packages owning files that
> >>>> you link to (line 78+ in guacamole.spec) must be mentioned in Requires,
> >>>> so that they are installed automatically. That is the point of having
> >>>> things packaged in the first place. Please, put all the required packages
> >>>> into Requires.

Corrected, I've added log4j and tomcat-native (comment #6); while the Java requirements are already in the SPEC file. The "guacd" daemon can be on another host and there can be multiple web interfaces for one daemon. So it should not be included as Requirement. You can see the configuration in guacamole.properties.

See also Package Description below, I added a note where to look for the centralized server.

> [!]: Package obeys FHS, except libexecdir and /usr/target.
> >>>> So, until the Web App Guidelines
> >>>> are approved and in place, I hereby ask you to refrain from installing
> >>>> anything in the /usr/share/webapps directory. Please use only
> >>>> /var/lib/tomcat/webapps.

Done; I also moved it up one level, see comment #2 and #3

from /usr/share/webapps/guacamole/guacamole/
to /var/lib/tomcat/webapps/guacamole/

> >>>> Also, I am not convinced that the file guacamole.properties should be
> >>>> installed in /usr/share/tomcat/lib. For one, it's not a library, and
> >>>> since stuff in /usr is read-only, it makes no sense to have a config
> >>>> file in there. Having the file in /etc/guacamole should be enough.

Done, I made a mistake by linking it 2 times in the SPEC file. It is now only located in /etc/guacamole/ and linked in /var/lib/tomcat/webapps/guacamole/WEB-INF/classes/

> [!]: If package contains pom.xml files install it (including depmaps) even
>      when building with ant
> >>>> Pom.xml file is present, but is not installed. Please, install it.

Done, I put only the pom.xml file as %add_maven_depmap throws an error.

> [!]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
> >>>> Line 96 should not copy the apidocs folder, but its contents:
> >>>> cp -rp target/site/apidocs/* %{buildroot}%{javadocdir}/%{name}/
> >>>> Currently there is the unnecessary directory apidocs in the path.

Corrected, but the Packaging Guidelines at https://fedoraproject.org/wiki/Packaging:Java#maven_3
suggest to copy directly the directory:

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -rp [javadoc directory] $RPM_BUILD_ROOT%{_javadocdir}/%{name}

I need to change it also in guacamole-common and guacamole-ext. Is it correct?
 
> [!]: Packages should try to preserve timestamps of original installed files.
> >>>> You are copying files without the -p switch, which preserves timestamps.
> >>>> It is not mandatory, but it would be nice having it.

Corrected.
 
> [ ]: Package Description
> >>>> It would be nice if the description didn't start with the word Guacamole.
 
Corrected, example taken from package kernel. Added note for centralized server.
Comment 16 Simone Caronni 2013-01-15 10:00:29 EST
$ rpmlint /home/slaanesh/rpmbuild/SRPMS/guacamole-0.7.0-2.fc17.src.rpm
guacamole.src: W: name-repeated-in-summary C Guacamole
guacamole.src: W: spelling-error %description -l en_US guacd -> guard
guacamole.src: W: spelling-error %description -l en_US libguac -> lingual
guacamole.src: W: invalid-license AGPLv3+
1 packages and 0 specfiles checked; 0 errors, 4 warnings.

I do not understand this, is it an rpmlint bug? The license is listed as valid in the package guidelines, fedora-review marks it ok and rpmlint does not.

> Generic:
> [x]: Package is licensed with an open-source compatible license and meets
>      other legal requirements as defined in the legal section of Packaging
>      Guidelines.
Comment 17 Simone Caronni 2013-01-15 10:01:38 EST
Spec URL: http://slaanesh.fedorapeople.org/guacamole.spec
SRPM URL: http://slaanesh.fedorapeople.org/guacamole-0.7.0-2.fc18.src.rpm

* Tue Jan 15 2013 Simone Caronni <negativo17@gmail.com> - 0.7.0-2
- Added Tomcat requirements (log4j, tomcat, tomcat-native).
- Moved application from /usr/share/webapps/guacamole/guacamole to
  /var/lib/tomcat/webapps/guacamole.
- Moved docs outside of the "apidocs" folder.
- Changed description with notes where to get the centralized server.
- Added pom.xml to installed files.
- Moved config file to /etc/guacamole and linked it to WEB-INF/classes.
Comment 18 Mikolaj Izdebski 2013-01-15 10:27:35 EST
(In reply to comment #15)
> > [!]: If package contains pom.xml files install it (including depmaps) even
> >      when building with ant
> > >>>> Pom.xml file is present, but is not installed. Please, install it.
> 
> Done, I put only the pom.xml file as %add_maven_depmap throws an error.

Depmap should be installed too. If you get an error message (or exception trace) then feel free to join our IRC channel (#fedora-java on freenode), we should be able to help.

> > [!]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
> > >>>> Line 96 should not copy the apidocs folder, but its contents:
> > >>>> cp -rp target/site/apidocs/* %{buildroot}%{javadocdir}/%{name}/
> > >>>> Currently there is the unnecessary directory apidocs in the path.
> 
> Corrected, but the Packaging Guidelines at
> https://fedoraproject.org/wiki/Packaging:Java#maven_3
> suggest to copy directly the directory:
> 
> mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}
> cp -rp [javadoc directory] $RPM_BUILD_ROOT%{_javadocdir}/%{name}

This is a "bug" in the guidelines :)
It should be [javadoc files] or [javadoc directory]/*

(In reply to comment #16)
> guacamole.src: W: invalid-license AGPLv3+
> 
> I do not understand this, is it an rpmlint bug? The license is listed as
> valid in the package guidelines, fedora-review marks it ok and rpmlint does
> not.

New licenses are added frequently so there is a delay between licensing page, so obviously rpmlint can't always contain the up-to-date list of license. That's especially true if you are using older (stable) releases instead of Rawhide.
Comment 19 Simone Caronni 2013-01-16 06:24:12 EST
Spec URL: http://slaanesh.fedorapeople.org/guacamole.spec
SRPM URL: http://slaanesh.fedorapeople.org/guacamole-0.7.0-3.fc18.src.rpm

* Wed Jan 16 2013 Simone Caronni <negativo17@gmail.com> - 0.7.0-3
- Removed pom.xml as per info in #fedora-java.

* Tue Jan 15 2013 Simone Caronni <negativo17@gmail.com> - 0.7.0-2
- Added Tomcat requirements (log4j, tomcat, tomcat-native).
- Moved application from /usr/share/webapps/guacamole/guacamole to
  /var/lib/tomcat/webapps/guacamole.
- Moved docs outside of the "apidocs" folder.
- Changed description with notes where to get the centralized server.
- Added pom.xml to installed files.
- Moved config file to /etc/guacamole and linked it to WEB-INF/classes.

Here is the macro error when I tried %add_maven_depmap (as already discussed in #fedora-java):

+ install -d -m 755 /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64/usr/share/maven-poms
+ install -pm 644 pom.xml /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64/usr/share/maven-poms/JPP.guacamole-guacamole.pom
+ set -e
+ _pompart=JPP.guacamole-guacamole.pom
+ _jarpart=guacamole/guacamole.jar
+ _filelist=.mfiles
+ install -dm 755 /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64//usr/share/maven-fragments
+ for _dir in /usr/lib64/java /usr/share/java-jni /usr/share/java
+ '[' -f /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64//usr/lib64/java/guacamole/guacamole.jar ']'
+ for _dir in /usr/lib64/java /usr/share/java-jni /usr/share/java
+ '[' -f /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64//usr/share/java-jni/guacamole/guacamole.jar ']'
+ for _dir in /usr/lib64/java /usr/share/java-jni /usr/share/java
+ '[' -f /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64//usr/share/java/guacamole/guacamole.jar ']'
+ python -m /usr/share/java-utils/maven_depmap /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64/usr/share/maven-fragments/guacamole /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64/usr/share/maven-poms/JPP.guacamole-guacamole.pom ''
Traceback (most recent call last):
  File "/usr/lib64/python2.7/runpy.py", line 162, in _run_module_as_main
    "__main__", fname, loader, pkg_name)
  File "/usr/lib64/python2.7/runpy.py", line 72, in _run_code
    exec code in run_globals
  File "/usr/share/java-utils/maven_depmap.py", line 295, in <module>
    fragment = parse_pom(pom_path, jar_path)
  File "/usr/share/java-utils/maven_depmap.py", line 142, in parse_pom
    raise PackagingTypeMissingFile(pom_path)
__main__.PackagingTypeMissingFile: Packaging type is not 'pom' and no artifact path has been provided for pom /builddir/build/BUILDROOT/guacamole-0.7.0-3.fc18.x86_64/usr/share/maven-poms/JPP.guacamole-guacamole.pom
error: Bad exit status from /var/tmp/rpm-tmp.9ZdB77 (%install)
    Bad exit status from /var/tmp/rpm-tmp.9ZdB77 (%install)

The package does not install any jar files, it does only symlink prerequisites:

$ ls -al /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/
total 8
drwxr-xr-x. 2 root root 4096 15 gen 16.03 .
drwxr-xr-x. 4 root root 4096 15 gen 16.03 ..
lrwxrwxrwx. 1 root root   29 15 gen 16.03 api.jar -> /usr/share/java/slf4j/api.jar
lrwxrwxrwx. 1 root root   46 15 gen 16.03 guacamole-common.jar -> /usr/share/java/guacamole/guacamole-common.jar
lrwxrwxrwx. 1 root root   43 15 gen 16.03 guacamole-ext.jar -> /usr/share/java/guacamole/guacamole-ext.jar
lrwxrwxrwx. 1 root root   40 15 gen 16.03 jcl-over-slf4j.jar -> /usr/share/java/slf4j/jcl-over-slf4j.jar

If there's the need to add it back I will do it, no problem.

Thanks,
--Simone
Comment 20 Tomas Radej 2013-01-21 03:38:47 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


[!]: Package complies to the Packaging Guidelines
[!]: Requires correct, justified where necessary.
>>>> You are linking to slf4j-owned files (lines 87, 88), but you do not
>>>> Require the package slf4j. Please, do that.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[-]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in %package
     javadoc
[!]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "AGPL (v3 or later)". 1 files have unknown license. Detailed output of
     licensecheck in /home/tradej/reviews/853922-guacamole/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: No %config files under /usr.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[!]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 81920 bytes in 3 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
[x]: Fully versioned dependency in subpackages, if present.
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
[x]: Bundled jar/class files should be removed before build

Maven:
[x]: Old add_to_maven_depmap macro is not being used
[-]: If package contains pom.xml files install it (including depmaps) even
     when building with ant

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

Java:
[x]: Package has BuildArch: noarch (if possible)
[x]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: guacamole-javadoc-0.7.0-3.fc19.noarch.rpm
          guacamole-0.7.0-3.fc19.src.rpm
          guacamole-0.7.0-3.fc19.noarch.rpm
guacamole-javadoc.noarch: W: invalid-license AGPLv3+
guacamole.src: W: name-repeated-in-summary C Guacamole
guacamole.src: W: spelling-error %description -l en_US guacd -> guard
guacamole.src: W: spelling-error %description -l en_US libguac -> lingual
guacamole.src: W: invalid-license AGPLv3+
guacamole.noarch: W: name-repeated-in-summary C Guacamole
guacamole.noarch: W: spelling-error %description -l en_US guacd -> guard
guacamole.noarch: W: spelling-error %description -l en_US libguac -> lingual
guacamole.noarch: W: invalid-license AGPLv3+
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/guacamole-ext.jar /usr/share/java/guacamole/guacamole-ext.jar
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/api.jar /usr/share/java/slf4j/api.jar
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/guacamole-common.jar /usr/share/java/guacamole/guacamole-common.jar
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/guacamole-common-js /usr/share/guacamole-common-js
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/jcl-over-slf4j.jar /usr/share/java/slf4j/jcl-over-slf4j.jar
3 packages and 0 specfiles checked; 0 errors, 14 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint guacamole-javadoc guacamole
guacamole-javadoc.noarch: W: invalid-license AGPLv3+
guacamole.noarch: W: name-repeated-in-summary C Guacamole
guacamole.noarch: W: spelling-error %description -l en_US guacd -> guard
guacamole.noarch: W: spelling-error %description -l en_US libguac -> lingual
guacamole.noarch: W: invalid-license AGPLv3+
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/guacamole-ext.jar /usr/share/java/guacamole/guacamole-ext.jar
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/api.jar /usr/share/java/slf4j/api.jar
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/guacamole-common.jar /usr/share/java/guacamole/guacamole-common.jar
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/guacamole-common-js /usr/share/guacamole-common-js
guacamole.noarch: W: dangling-symlink /var/lib/tomcat/webapps/guacamole/WEB-INF/lib/jcl-over-slf4j.jar /usr/share/java/slf4j/jcl-over-slf4j.jar
2 packages and 0 specfiles checked; 0 errors, 10 warnings.
# echo 'rpmlint-done:'



Requires
--------
guacamole-javadoc-0.7.0-3.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    jpackage-utils

guacamole-0.7.0-3.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    config(guacamole) = 0.7.0-3.fc19
    guacamole-common = 0.7.0
    guacamole-common-js = 0.7.0
    guacamole-ext = 0.7.0
    java
    jpackage-utils
    log4j
    tomcat
    tomcat-native



Provides
--------
guacamole-javadoc-0.7.0-3.fc19.noarch.rpm:
    
    guacamole-javadoc = 0.7.0-3.fc19

guacamole-0.7.0-3.fc19.noarch.rpm:
    
    config(guacamole) = 0.7.0-3.fc19
    guacamole = 0.7.0-3.fc19



MD5-sum check
-------------
http://downloads.sourceforge.net/guacamole/guacamole-0.7.0.tar.gz :
  CHECKSUM(SHA256) this package     : 65bce57269c249423d07fce12692e26f88a8c67f25f77ee854177d406743fbaf
  CHECKSUM(SHA256) upstream package : 65bce57269c249423d07fce12692e26f88a8c67f25f77ee854177d406743fbaf


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 853922 -m fedora-rawhide-x86_64

*** NOT APPROVED ***

Please, just add Requires on slf4j and the package is good to go.
Comment 21 Simone Caronni 2013-01-21 03:55:17 EST
(In reply to comment #20)
> [!]: Requires correct, justified where necessary.
> >>>> You are linking to slf4j-owned files (lines 87, 88), but you do not
> >>>> Require the package slf4j. Please, do that.
>
> Please, just add Requires on slf4j and the package is good to go.

Ooops, I missed that. Thanks.

Spec URL: http://slaanesh.fedorapeople.org/guacamole.spec
SRPM URL: http://slaanesh.fedorapeople.org/guacamole-0.7.0-4.fc18.src.rpm

* Mon Jan 21 2013 Simone Caronni <negativo17@gmail.com> - 0.7.0-4
- Added missing slf4j requirement.
Comment 22 Tomas Radej 2013-01-21 05:29:16 EST
The release number is wrong (is 5, should be 4), but I trust you with fixing that before uploading to the repository.

*** APPROVED ***
Comment 23 Simone Caronni 2013-01-21 05:39:28 EST
Thanks, it was bumped by rpmdev-bumspec. Fixed locally.

Many thanks for the time spent on the review and in #fedora-java!
Comment 24 Simone Caronni 2013-01-21 05:42:04 EST
New Package SCM Request
=======================
Package Name: guacamole
Short Description: The main Guacamole web application
Owners: slaanesh
Branches: f16 f17 f18 el6
InitialCC:
Comment 25 Simone Caronni 2013-01-22 08:28:58 EST
(In reply to comment #23)
> Thanks, it was bumped by rpmdev-bumspec. Fixed locally.

I also added the new "BuildRequires: maven-local" in the spec file.
Comment 26 Gwyn Ciesla 2013-01-22 08:58:09 EST
Git done (by process-git-requests).
Comment 27 Fedora Update System 2013-01-23 03:51:20 EST
libguac-client-vnc-0.7.0-2.el6,libguac-client-rdp-0.7.2-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/libguac-client-vnc-0.7.0-2.el6,libguac-client-rdp-0.7.2-1.el6
Comment 28 Fedora Update System 2013-01-23 03:52:23 EST
guacamole-0.7.1-1.fc17,guacamole-ext-0.7.0-2.fc17,guacamole-common-0.7.0-2.fc17,libguac-client-vnc-0.7.0-2.fc17,libguac-client-rdp-0.7.2-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/guacamole-0.7.1-1.fc17,guacamole-ext-0.7.0-2.fc17,guacamole-common-0.7.0-2.fc17,libguac-client-vnc-0.7.0-2.fc17,libguac-client-rdp-0.7.2-1.fc17
Comment 29 Fedora Update System 2013-01-23 03:53:04 EST
guacamole-0.7.1-1.fc18,guacamole-ext-0.7.0-2.fc18,guacamole-common-0.7.0-2.fc18,libguac-client-vnc-0.7.0-2.fc18,libguac-client-rdp-0.7.2-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/guacamole-0.7.1-1.fc18,guacamole-ext-0.7.0-2.fc18,guacamole-common-0.7.0-2.fc18,libguac-client-vnc-0.7.0-2.fc18,libguac-client-rdp-0.7.2-1.fc18
Comment 30 Fedora Update System 2013-01-28 08:33:23 EST
guacamole-0.7.1-1.fc16,guacamole-ext-0.7.0-2.fc16,guacamole-common-0.7.0-2.fc16,libguac-client-vnc-0.7.0-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/guacamole-0.7.1-1.fc16,guacamole-ext-0.7.0-2.fc16,guacamole-common-0.7.0-2.fc16,libguac-client-vnc-0.7.0-2.fc16
Comment 31 Fedora Update System 2013-02-01 23:24:56 EST
guacamole-0.7.1-1.fc17, guacamole-ext-0.7.0-2.fc17, guacamole-common-0.7.0-2.fc17, libguac-client-vnc-0.7.0-2.fc17, libguac-client-rdp-0.7.2-1.fc17 has been pushed to the Fedora 17 stable repository.
Comment 32 Fedora Update System 2013-02-01 23:34:07 EST
guacamole-0.7.1-1.fc18, guacamole-ext-0.7.0-2.fc18, guacamole-common-0.7.0-2.fc18, libguac-client-vnc-0.7.0-2.fc18, libguac-client-rdp-0.7.2-1.fc18 has been pushed to the Fedora 18 stable repository.
Comment 33 Fedora Update System 2013-02-07 21:10:24 EST
guacamole-0.7.1-1.fc16, guacamole-ext-0.7.0-2.fc16, guacamole-common-0.7.0-2.fc16, libguac-client-vnc-0.7.0-2.fc16 has been pushed to the Fedora 16 stable repository.
Comment 34 Fedora Update System 2013-02-12 15:24:30 EST
libguac-client-vnc-0.7.0-2.el6, libguac-client-rdp-0.7.2-1.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.